package redis

import (
	"fmt"
	"github.com/go-redis/redis"
	setting "icloudapp.cn/tools/config"
)

var (
	RedisClient *redis.Client
	Nil         = redis.Nil
)

// Init 初始化连接
func Init(cfg *setting.RedisConfig) {
	RedisClient = redis.NewClient(&redis.Options{
		Addr:         fmt.Sprintf("%s:%d", cfg.Host, cfg.Port),
		Password:     cfg.Password, // no password set
		DB:           cfg.DB,       // use default DB
		PoolSize:     cfg.PoolSize,
		MinIdleConns: cfg.MinIdleConns,
	})

	_, err := RedisClient.Ping().Result()
	if err != nil {
		panic(fmt.Sprintf("redis connect err, \v", err))
	}
}

func Close() {
	_ = RedisClient.Close()
}

/*
---- 测试写入和获取字符串 ----
RedisClient.Set("username", "zhangsan", 0).Err()
username, _ := RedisClient.Get("username").Result()
fmt.Println(username)  // zhangsan
*/
