package router

import (
	"github.com/gin-gonic/gin"
	"icloudapp.cn/tools/controller"
	"icloudapp.cn/tools/middleware"
)

func SetupApiRouters(r *gin.Engine) {
	v1 := r.Group("/api/v1")
	v1.Use(middleware.AuthMiddleware())
	/*
		v1.GET("pipeline/:id", controller.GetPipelineDetailHandler)
		v1.GET("pipeline", controller.GetPipelineListHandler)
		v1.POST("pipeline", controller.CreatePipelineHandler)
		v1.PUT("pipeline", controller.UpdatePipelineHandler)
		v1.DELETE("pipeline/:id", controller.DeletePipelineHandler)
	*/
	r.GET("/index", controller.Index)

	user := r.Group("/api/user")
	user.GET("/info", controller.Info)
	user.GET("/login", controller.Login)
	user.POST("/login", controller.Login)

	user.GET("/register", controller.Register)
	user.POST("/register", controller.Register)

	poster := r.Group("/api/poster")
	poster.GET("/info", controller.PosterInfo)
	poster.GET("/image", controller.Image)
	poster.GET("/cut", controller.Cut)
	poster.POST("/save", controller.SavePoster)
	poster.GET("/preview", controller.Preview)
	poster.GET("/draw", controller.DrawImage)
}
