package util

import (
	"fmt"
	"gopkg.in/gographics/imagick.v3/imagick"
	"math/rand"
	"testing"
)

func TestEncrypt(t *testing.T) {

	str := Encrypt("password", "key")
	if str == "" {
		t.Error("加密失败")
	}
	fmt.Println("加密结果：", str)
}

func TestDecrypt(t *testing.T) {
	key := "oadsoas"
	str := "password"
	encode := Encrypt(str, key)

	decode := Decrypt(encode, key)

	if str != decode {
		t.Error("加解密失败")
	}
	fmt.Println("str :", str, "加密解密结果:", decode)
}

func TestRandomNumberStr(t *testing.T) {
	s := RandomNumberStr(8)

	fmt.Println("random number string", s)
}

func TestRandomStr(t *testing.T) {
	s := RandomStr(8)

	fmt.Println("random string", s)

	letterBytes := "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"

	b := make([]byte, 8)
	for i := range b {
		b[i] = letterBytes[rand.Intn(len(letterBytes))]
	}
	fmt.Println(string(b))
}

func TestRandNum(t *testing.T) {
	fmt.Println("rand num", RandNum(1000))
	fmt.Println("rand num", RandNum(10000))

	letterBytes := "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"

	b := make([]byte, 8)
	for i := range b {
		b[i] = letterBytes[rand.Intn(len(letterBytes))]
	}
	fmt.Println(string(b))
}

func TestGenerateKey(t *testing.T) {
	fmt.Println(GenerateKey([]byte("nadsnadsfads")))

	imagick.Initialize()
	defer imagick.Terminate()

	mw := imagick.NewMagickWand()
	pw := imagick.NewPixelWand()
	defer pw.Destroy()

	// Create the initial 640x480 transparent canvas
	pw.SetColor("none")

	if err := mw.NewImage(100, 100, pw); err != nil {
		fmt.Println("error")
	}
	mw.SetImageFormat("PNG")
	mw.WriteImage("go-test.png")
	fmt.Println(mw.GetImageBlob())
}
